<?xml version="1.0" encoding="UTF-8"?>
<xsl:stylesheet xmlns:xsl="http://www.w3.org/1999/XSL/Transform" version="3.0">
    <!-- The input JSON file -->
    <xsl:param name="input" select="'url to json file'"/>

    <xsl:template match=".[. instance of map(*)]">
        <html>
            <head>
                <title>Recommended Books</title>
            </head>
            <body>
                <h1>The list of recommended books</h1>
                <table cellspacing="12px">
                    <xsl:apply-templates select="?books" mode="processBook"/>
                </table>
            </body>
        </html>
    </xsl:template>

    <!-- Template that matches the maps -->
    <xsl:template match=".[. instance of map(*)]" mode="processBook">
        <h3><xsl:value-of select="?title"/></h3>
        <p>by <xsl:value-of select="?author"/></p>
    </xsl:template>
</xsl:stylesheet>
